//
// fbuf.h - buffering layer
//
#if !defined(__FBUF_H__)
#define __FBUF_H__

#define NBUFS     256
#define MINBUF    131072

class fbuf {
  char *buffer[NBUFS];  
  long  offset[NBUFS];
  int   size[NBUFS];
  int   dirty[NBUFS];
  int   locks[NBUFS];
  int   fd;
  int   rip;

  int   numsnode;
  long *snoffs;        // store original matrix layout 
  int  *snsize;

public:
  // constructor 
  fbuf(int numsnode, long *snoffset, int *snodsize, int fid);

  // access functions
  char *fbget(int snode, long offset = -1L);
  void  fbaccess(int numaccess, int *list);
  char *fbread(int sno, long offset, int size);
  void  fbwrite(char *buffer, long offset, int size);

  void  flock(int snode);
  void  funlock(int snode);

  // internal methods
  int fsearch(long ofs, int sz);
  int falloc(int sno, int mode = 0);
  int falloc_check(int sno);
  char *foffset(int ndx, long ofs);

  void status(void);
};


#endif
