//
// snode.h
//
// $Header: /fs/nene/uysal/mambo/cholesky/fact/RCS/snode.h,v 1.1 1997/02/28 06:51:27 uysal Exp uysal $
//
// Definition of supernode class
//
// Author : Mustafa Uysal <uysal@cs.umd.edu>
//
//
#if !defined(__SNODE_H__)
#define __SNODE_H__

#include "datatype.h"

class SNode {
  int colStart;          // first column index in the supernode 
  int nrows;             // # of rows in the supernode
  int ncols;             // # of columns in the supernode
  int *index;            // index set - row numbers of nonzeros
  elem_t *data;          // array of size nrows * (endCol - staCol)

  int depcnt;            // Optional dependency structures
  int *updndx;
	
public:
  SNode( void )
  {
    nrows  = ncols = colStart = depcnt = 0;
    index  = NULL;
    data   = NULL;
    updndx = NULL;
  };

};

#endif
