/*
 * sp.mpl.c
 */
#include <mpproto.h>
#include "trace.h"

int mpl_asend(int to, int tag, int size, void *buf)
{
  int tmp;
#if defined(TRACE)
  MPC_ASEND(buf, size, to, tag, &tmp);
#else
  mpc_send(buf, size, to, tag, &tmp);
#endif
  return tmp;
}

int mpl_arecv(int *tag, int *src, int size, void *buf)
{
  int mid;
#if defined(TRACE)
  MPC_ARECV(buf, size, src, tag, &mid);
#else
  mpc_recv(buf, size, src, tag, &mid);
#endif
  return mid;
}

int mpl_mwait(int id)
{
  size_t size;
#if defined(TRACE)
  MPC_WAIT(&id, &size);
#else
  mpc_wait(&id, &size);
#endif
  return (int) size;
}

void mpl_bsend(int to, int tag, int size, void *buf)
{
#if defined(TRACE)
  MPC_BSEND(buf, size, to, tag);
#else
  mpc_bsend(buf, size, to, tag);
#endif
}


void mpl_brecv(int *tag, int *src, int *size, void *buf)
{
  size_t sv   = *size;
  int    lsrc = *src;
  int    ltag = *tag;
  
#if defined(TRACE)
  MPC_BRECV(buf, sv, &lsrc, &ltag, &sv);
#else
  mpc_brecv(buf, sv, &lsrc, &ltag, &sv);
#endif

  *size = sv;
  *src  = lsrc;
  *tag  = ltag;
}

