/*
 * disk.h
 *
 * $Source: /fs/nene/uysal/npFact/RCS/disk.h,v $
 *
 * $Header: /fs/nene/uysal/npFact/RCS/disk.h,v 1.1 1995/10/16 03:42:25 uysal Exp $
 *
 * Disk Manager functions
 *
 * Author : Mustafa Uysal (uysal@cs.umd.edu)
 *
 */
#ifndef __DISK_H__
#define __DISK_H__

#include <aio.h>
#include "world.h"
#include "snode.h"


#define DSK_FIRST  0
#define DSK_NEXT   1



/*--------------- Exported Functions ---------------*/

/* Routine to initialize Disk module */
void DiskInit ARGS((char *fn, int *ns, int **ofptr, int **szptr));

/* Housekeeping and cleanup routine for disk module */
void DiskExit ARGS(( void ));

/* Routine to report the status of the Disk module */
void DiskStatus ARGS((void));

/* Blocking read of local supernode data (if necesssary) */
snode_t *DiskReadLocal ARGS((snode_t *sptr, int mode));

/* Blocking write of local supernode data */
void DiskWriteLocal ARGS((snode_t *ptr));

#endif  __DISK_H__
