/*
 * snode.h
 *
 * $Source: /fs/nene/uysal/npFact/RCS/snode.h,v $
 *
 * $Header: /fs/nene/uysal/npFact/RCS/snode.h,v 1.2 1995/12/27 02:00:09 uysal Exp $
 *
 * Resource management routines for managing the
 * blocks in a supernode
 *
 * Author : Mustafa Uysal <uysal@cs.umd.edu>
 *
 */
#ifndef __SNODE_H__
#define __SNODE_H__

#include "world.h"
#include "block.h"


/*--------------- Data Types ---------------*/

typedef struct snode {
  int sid;         /* supernode number */
  int offset;      /* Location on the local disk */
  int size;        /* size of local block descriptors + data */

  caddr_t buffer;  /* buffer into which the data is stored */
  
  int blkcnt;      /* # of local blocks on processor */
  block_t *blkPtr; /* block descriptors */
} snode_t;


/*--------------- Exported Functions ---------------*/

/* Routine to initialize supernode control structure */
void SnodeInit ARGS((int cnt, int *offset, int *size));

/* Routine to extract the dependent supernode list */
int *SnodeUpdaters ARGS((snode_t *sptr, int *cnt));

/* Routine to allocate and initialize mem space */
snode_t *SnodeAlloc ARGS((int id, int offset, int size));

/* Routine to reclaim memory allocated by a supernode */
void SnodeFree ARGS(( snode_t *ptr ));

/* Routine to service a supernode request from memory */
snode_t *SnodeRequest ARGS((int id));

#endif  __SNODE_H__
