/*
 * sp2.c
 *
 * $Source: /fs/nene/uysal/npFact/RCS/sp2.c,v $
 *
 * $Header: /fs/nene/uysal/npFact/RCS/sp2.c,v 1.2 1995/12/27 02:00:09 uysal Exp $
 *
 * Implementation of configuration and message passing functions for
 * the IBM SP-2 platform.
 *
 * Author : Mustafa Uysal <uysal@cs.umd.edu>
 *
 * Notes : 
 *
 */
#include <mpproto.h>

#if    !defined(SP2)
#define SP2
#endif !defined(SP2)

#include "world.h"
#include "mppworld.h"
#include "queue.h"
#include "debug.h"


static int me, np;

/* Statistics Variables */
static double c_snd, c_rcv;
static double c_drnw, c_drnwnum;
static double c_sflush, c_drain, c_poll;
static long c_svl, c_rvl;



/*-------------- Local Function Prototypes ---------------------*/
double w_seconds ARGS((void));


/*--------------- Implementation ---------------*/


int NumProcs( VOID )
{
  int numtask, taskid;

  mpc_environ(&numtask, &taskid);
  return(numtask);
}




int MyProc( VOID )
{
  int numtask, taskid;

  mpc_environ(&numtask, &taskid);
  return(taskid);  
}



void MPPinit()
{
  /* bare essentials */
  me = MyProc();
  np = NumProcs();

  /* product version tracking */
#if defined(SP2)
  print_if(!me, ("\nSP-2 custom version for Communication Software"));
#else
  print_if(!me, ("\nGeneric communication software"));
#endif

  c_snd = c_rcv = c_drnw = c_drnwnum = c_sflush = c_drain = c_poll = 0.0;
  c_svl = c_rvl = 0;
} 



/* Routine to report the state of the MPP routine */
void MPPstatus()
{
}


double CLOCK()
{
  return w_seconds();
}




void Sync( void )
{
  mpc_sync(ALLGRP);
}






