/*
 * blas.h
 *
 * $Source: /fs/nene/uysal/pf/newFact/RCS/blas.h,v $
 *
 * $Header: /fs/nene/uysal/pf/newFact/RCS/blas.h,v 1.1 1995/10/16 03:42:25 uysal Exp $
 *
 * Header file for portable calling sequence of BLAS routines
 *
 * Author : Mustafa Uysal <uysal@cs.umd.edu>
 * 
 */
#ifndef __BLAS_H__
#define __BLAS_H__

#if   defined(REAL)


#if   defined(DOUBLE)       /* Double Precision, REAL */
double   ddot();
#define  DOT   ddot
#define  AXPY  daxpy
#define  SCAL  dscal
#define  GEMV  dgemv
#define  GEMM  dgemm

#elif defined(SINGLE)       /* Single Precision, REAL */
float    sdot();
#define  DOT   sdot
#define  AXPY  saxpy
#define  SCAL  sscal
#define  GEMV  sgemv
#define  GEMM  sgemm
#else
#error "One of DOUBLE or SINGLE must be defined in blas.h"
#endif


#elif defined(COMPLEX)

#if   defined(DOUBLE)        /* Double Precision, COMPLEX */
#define  AXPY  zaxpy
#define  SCAL  zscal
#define  GEMV  zgemv
#define  GEMM  zgemm

#elif defined(SINGLE)        /* Single Precision, COMPLEX */
#define  AXPY  caxpy
#define  SCAL  cscal
#define  GEMV  cgemv
#define  GEMM  cgemm

#else
#error "One of DOUBLE or SINGLE must be defined in blas.h"
#endif


#else
#error "One of COMPLEX or REAL must be defined in blas.h"
#endif

#endif __BLAS_H__
