/*
 * comm.h
 *
 * $Source: /fs/nene/uysal/pf/newFact/RCS/comm.h,v $
 *
 * $Header: /fs/nene/uysal/pf/newFact/RCS/comm.h,v 1.1 1995/10/16 03:42:25 uysal Exp $
 *
 * Export module for comm.c 
 *
 * Author : Mustafa Uysal (uysal@cs.umd.edu)
 *
 */
#ifndef __COMM_H__
#define __COMM_H__

#include <mpproto.h>
#include "world.h"
#include "block.h"

/*--------------- Exported Functions ---------------*/

/* Module initialization */
int *CommInit ARGS((int *plevel));

/* Module housekeeping and cleanup */
void CommExit ARGS((void));

/* Module status report */
void CommStatus ARGS((void));

/* Routine to shuffle blocks to where they needed */
block_t *CommBlockReceive ARGS((int pid, snode_t *src, int me, int *count));

/* Routine to multicast the diagonal of the pivot */
block_t *CommDiagRecv ARGS((snode_t *sptr, int me));

/* Routine to inform Network Interface that we are waiting a msg */
void NetPrefetchBase ARGS((int sid, int pid));


#endif  __COMM_H__




