/*
 * disk.h
 *
 * $Source: /fs/nene/uysal/pf/Part/RCS/disk.h,v $
 *
 * $Header: /fs/nene/uysal/pf/Part/RCS/disk.h,v 1.2 1995/10/09 19:27:01 uysal Exp $
 *
 * Signatures of Routines to handle the disk I/O requests for the 
 * block partitioner
 *
 * Author : Mustafa Uysal <uysal@cs.umd.edu>
 *
 */
#ifndef __DISK_H__
#define __DISK_H__


#include "part.h"

/* routine to initialize DISK module */
int DiskBlockifyInit();

/* routine to read a range of columns into memory (async-collective) */
column_t *ReadColumnRange(int map, int sta, int end, int *cnt);

/* Routine to report disk I/O performance */
void DiskIOReport(void);

/* Routine to initialize timing variables */
void DiskTimingInit(void);

#endif  __DISK_H__
