/*
 * ipc.c
 *
 * $Source: /fs/nene/uysal/pf/Part/RCS/ipc.c,v $
 *
 * $Header: /fs/nene/uysal/pf/Part/RCS/ipc.c,v 1.1 1995/09/21 04:26:45 uysal Exp $
 *
 * Inter Processor Communications Module 
 * Application Specific Routines
 *
 * Author : Mustafa Uysal <uysal@cs.umd.edu>
 *
 */
#include <math.h>

#include "world.h"
#include "mppworld.h"

#include "part.h"
#include "mtags.h"

static int colcnt;

static int **pgrid;     /* Processor grid */
static int   gridx;
static int   gridy;



void CompProcGrid ARGS((int np));

/*--------------- Implementation ---------------*/


void CommBlockifyInit()
{
  CompProcGrid(NumProcs());
}



void CommBlockifyExit()
{
}



/*
 * Generation of processor grid for 
 * block partitioning
 */
void CompProcGrid(np)
    int np;     /* number of processors */
{
  double tmp;                   /* to get the result of sqrt */
  int *gptr;                    /* pointer to a row of pgrid */
  int i,j,k,cnt;                /* control vars */

  /* find out grid parameters */
  tmp = sqrt((double)np);
  gridy = (int) tmp;
  gridx = np/gridy;
  if ((gridy*gridx)<np)
    gridx++;

  /* storage allocation */
  pgrid = (int**) calloc(gridy, sizeof(int*));
  CHKNULL(pgrid);
  
  /* fill-up the processor grid */
  for (cnt=i=0; i<gridy; i++)
    {
      gptr = pgrid[i] = (int*) calloc(gridx, sizeof(int));
      CHKNULL(gptr);
      
      for (j=0; j<gridx; j++, cnt++)
        gptr[j] = cnt % np;
    }
}



int BlockMapping(x,y)
    int x,y;
{
  return (pgrid[y % gridy][x % gridx]);
}




