/*
 * list.h
 *
 * $Source$
 *
 * $Header$
 *
 * Functions exported by list.c
 *
 * Author : Mustafa Uysal <uysal@cs.umd.edu>
 *
 */
#if !defined(__LIST_H__)
#define __LIST_H__

#include "world.h"


typedef struct listnode {
  caddr_t data;
  struct listnode *next;
} listnode_t;


typedef struct {
  int load;
  listnode_t *head;
  listnode_t *tail;
} list_t;


/*--------------- Function Prototypes ---------------*/

/* Routine to create a new list structure */
list_t *ListNew ARGS((void));

/* Routine to destroy a list structure */
void ListDestroy ARGS((list_t *lp));

/* Routine to insert an item into the list at the tail */
void ListInsertTail ARGS((list_t *lp, caddr_t dp));

/* Routine to lookup an item in the list */
caddr_t  ListLookup ARGS((list_t *lp, caddr_t dp, int (*fn)()));

/* Routine to find and delete an item from the list */
caddr_t ListFindDelete ARGS((list_t *lp, caddr_t dp, int (*fn)()));

/* Routine to delete the head of the list */
caddr_t ListDeleteHead ARGS((list_t *lp));

/* Routine to check whether the list is empty or not */
int ListEmpty ARGS((list_t *lp));

/* Routine to print all members of the list */
void ListPrintAll ARGS((list_t *lp, void (*pf)()));

#endif defined(__LIST_H__)
