/*
 * map.c
 *
 * $Source: /fs/nene/uysal/pf/Part/RCS/map.c,v $
 *
 * $Header: /fs/nene/uysal/pf/Part/RCS/map.c,v 1.1 1995/09/21 04:26:45 uysal Exp $
 *
 * Symbolic factorization code may write out the symbolic factor
 * signature in various different forms. This module adapts
 * to which form is used by the symbolic factorization by supporting
 * different mappings.
 *
 * Author : Mustafa Uysal <uysal@cs.umd.edu>
 *
 */

#include "map.c"


#ifdef BLK_CYC
int block_size = 100;
#endif




#ifdef CYCLIC
int ColMap( col )
    int col;
{
  return (col % NumProcs());
}



int ColNdx( col )
    int col;
{
  return (col / NumProcs());
}

#elif defined(BLK_CYC)

int ColMap(col)
    int col;
{
  return ((col/block_size) % NumProcs());
}


int ColNdx(col)
    int col;
{
  return (col/(block_size*NumProcs()))*block_size + col % block_size;
}

#endif
