//
// column.h
//
// $Header: /fs/nene/uysal/mambo/cholesky/part/RCS/column.h,v 1.1 1997/02/26 21:05:26 uysal Exp uysal $
//
// Definition of sparse column class
//
// Author : Mustafa Uysal <uysal@cs.umd.edu>
//
// $Log: column.h,v $
// Revision 1.1  1997/02/26 21:05:26  uysal
// Initial revision
//
//
//
#if !defined(__COLUMN_H__)
#define __COLUMN_H__

#include "datatype.h"

class Column {
  int colno;             // column number or id
  int nrows;             // # of rows in the column
  int *index;            // index set - row numbers of nonzeros
  elem_t *data;         // array of size nrows 
	
public:
  Column( void )
  {
    colno = nrows = 0;
    index = NULL;
    data  = NULL;
  };

  Column(int no, int nr, int *ndx, elem_t *nz = NULL)
  {
    colno = no;
    nrows = nr;
    index = ndx;
    data  = nz;
  };

  int colid(void)    
  { 
    return colno; 
  };
  
  int size(void)     
  { 
    return nrows; 
  };
  
  int sameStruct( Column &next )
  {
    if (next.nrows != (nrows - 1)) return 0;

    for (int i=1; i<nrows; i++)
      if (index[i] != next.index[i-1])
	return 0;

    return 1;
  };
};

#endif
