#include <fcntl.h>
#include <sys/trcctl.h>
#include "trace_defs.h"

int   ctl_fd;
char *ctrl_dev   = "/dev/systrctl";
char *trace_file = NULL;
char *trace_args = "-ad -L2000000000 -T1000000 -j\"101,107,104,12E,130,154,15B,163,19C,010,020,030,040\"";
char trace_bufp[1024];



void trace_init(char *name)
{
  trace_file = name;
}


void trace_start(void)
{
  sprintf(trace_bufp, "%s -o %s", trace_args, trace_file);
  if (trcstart(trace_bufp))  /* configure trace collection */
    {
      perror("trcstart");
      exit(1);
    }
  if (trcon(0))              /* turn data collection on */
    {
      perror("trcon");
      exit(1);
    }
}


void trace_end(void)
{
  if (trcoff(0))    /* turn data collection off */
    {
      perror("trcoff");
      exit(1);
    }

  if (trcstop(0))   /* stop trace deamon */
    {
      perror("trcstop");
      exit(1);
    }
}
