/*
 * trace_defs.h 
 *
 * Author : Mustafa Uysal <uysal@cs.umd.edu>
 *
 */
#if !defined(_TRACE_DEFS_H__)
#define _TRACE_DEFS_H__

#include <mpproto.h>

#include <sys/trcctl.h>
#include <sys/trcmacros.h>
#include <sys/trchkid.h>

#define TRC_MSG_BSEND   HKWD_USER1
#define TRC_MSG_BRECV   HKWD_USER2
#define TRC_MSG_SNDRCV  HKWD_USER3
#define TRC_MSG_FINISH  HKWD_USER4

/*
#define TRC_MSG_ASEND   HKWD_USER3
#define TRC_MSG_ARECV   HKWD_USER4

#define TRC_MSG_WAIT    HKWD_USER6
#define TRC_MSG_PROBE   HKWD_USER7
*/



/* MPL library calls are redefined : */

#define MPC_BSEND(m,l,d,t)                {\
  TRCHKL3T(TRC_MSG_BSEND,l,d,t);\
  mpc_bsend(m,l,d,t);\
  TRCHKL1T(TRC_MSG_FINISH,TRC_MSG_BSEND);\
}

#define MPC_BRECV(m,l,s,t,b)              {\
  TRCHKL3T(TRC_MSG_BRECV,l,*(s),*(t));\
  mpc_brecv(m,l,s,t,b);\
  TRCHKL4T(TRC_MSG_FINISH,TRC_MSG_BRECV,(*s),(*t),(*b));\
}

#define MPC_BSENDRECV(om,ol,d,t,im,il,is,ib)  {\
  TRCHKL5T(TRC_MSG_SNDRCV,ol,d,t,il,(*is));\
  mpc_bsendrecv(om,ol,d,t,im,il,is,ib);\
  TRCHKL4T(TRC_MSG_FINISH,TRC_MSG_SNDRCV,(*is),t,(*ib));\
}

#endif
