//
// buffer.h
//
// Quick and dirty hack for a dynamically extensible buffer
//
// Author : Mustafa Uysal <uysal@cs.umd.edu>
//
#if !defined(__BUFFER_H__)
#define __BUFFER_H__

#include <iostream.h>
#include "vector.h"

#define MIN_BUF_SIZE  100

class Buffer : public Vector {
  int nused;

public:
  Buffer(void) : Vector(MIN_BUF_SIZE)
  {
    nused = 0;
  };

  Buffer(int size) : Vector((size>MIN_BUF_SIZE)?size:MIN_BUF_SIZE)
  {
    nused = 0;
  };

  int numUsed( void )
  {
    return nused;
  }

  // append an integer into the buffer
  // expand the storage if full
  void append(int elem)
  {
    this->setElem(nused, elem);
    nused++;
    if (nused == this->getSize())
      this->expand(this->getSize());
  };


  void merge(int cnt, int *data)
  {
    this->Vector::merge(cnt, nused, data);
    nused += cnt;
  }

  void print(void)
  {
    cout << " first = " << this->getElem(0) << " last = " << this->getElem(nused-1) 
	 << " (total of " << nused << " entries).\n";
  }

  void print(int numInLine)
  {
    for (int k = 0; k < nused; k += numInLine)
      {
	for (int j = 0; (j < numInLine) && (k+j < nused); j++)
	  cout << " " << this->getElem(k+j);
	cout << "\n";
      }
  }
};

#endif
