/*
 * queue.h
 *
 * $Source: /fs/nene/uysal/mambo/cholesky/symbolic/RCS/queue.h,v $
 *
 * $Header: /fs/nene/uysal/mambo/cholesky/symbolic/RCS/queue.h,v 1.1 1995/09/08 05:53:32 uysal Exp $
 *
 * Signature for a queue implementation. 
 * 
 * Author    : Anurag Acharya <acha@cs.umd.edu>
 * Revisions : Mustafa Uysal  <uysal@cs.umd.edu>       
 *
 */
#ifndef __QUEUE_H__
#define __QUEUE_H__

/* to get caddr_t -- many compilers don't like mortals defining caddr_t */
#include <sys/types.h>

typedef struct {
  caddr_t   *base;
  int        head;
  int        tail;
  int        size;
  int        load;
} queue_t;

/* routine to make a queue */
extern queue_t *QueueNew ARGS((void));

/* routine to extend a queue */
extern queue_t *queue_extend ARGS((queue_t *q));

/* routine to free a queue */
extern void QueueDestroy ARGS((queue_t *q));

/* routine to add an item to a queue */
extern void QueueAdd ARGS((queue_t *q, caddr_t item));

/* routine to delete an item from the queue */
extern caddr_t QueueDelete ARGS((queue_t *q));

/* routine to probe the head of the queue */
extern caddr_t QueueHead ARGS((queue_t *q));

/* routine to see if a queue is empty */
extern int QueueEmpty ARGS((queue_t *q));

#endif 


